require 'stbaldricks/endpoints/lib/entity'
require 'stbaldricks/request'

module SBF
  module Client
    class ConfigEndpoint < SBF::Client::EntityEndpoint
      def reload(entity)
        response = SBF::Client::Api::Request.get_request("#{base_uri}/get")
        parsed_response_body = JSON.parse(response.body).symbolize!

        raise SBF::Client::StandardError, 'Unable to retrieve settings from the api' unless ok?(response)

        # re-call initalize with the new api data. This should re-set all of the instance variables on the instance
        entity.send(:initialize, parsed_response_body)
      end
    end
  end
end
