require 'stbaldricks/endpoints/lib/entity'
require 'ipaddr'

module SBF
  module Client
    class DonationEndpoint < SBF::Client::EntityEndpoint
      def create(entity_or_hash, with = {})
        unless SBF::Client::Configuration.forwarded_for
          SBF::Client::LOG.warn do
            "SBF::Client No forwarded_for configured for the client on the donation create route. \
              This may cause your app to be blocked from creating donations if too many errors occur."
          end
        end
        super
      end

      def external_sync(data)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/external_sync", data)

        unless ok?(response)
          parsed_response_body = JSON.parse(response.body).symbolize!
          error = SBF::Client::ErrorEntity.new(parsed_response_body)
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: response, error: error)
      end
    end
  end
end
