require 'stbaldricks/endpoints/lib/entity'

module SBF
  module Client
    class FundEndpoint < EntityEndpoint
      def allowed_entities(params)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/allowed_entities", params)
        parsed_response_body = JSON.parse(response.body).symbolize!

        if ok?(response)
          data = parsed_response_body
          model_type = SBF::Client::ModelType.list[params[:dest_model_type]].capitalize
          entity_class = "SBF::Client::Full#{model_type}".to_class
          data[:results].map! { |entity| entity_class.new(entity) }
        else
          error = SBF::Client::ErrorEntity.new(parsed_response_body)
          data = nil
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: data, error: error)
      end
    end
  end
end
