require 'stbaldricks/endpoints/lib/entity'

module SBF
  module Client
    class FundraiserEndpoint < EntityEndpoint
      def join_team(fundraiser_id, new_team_id)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/move_to_different_team", id: fundraiser_id, new_team_id: new_team_id)

        if ok?(response)
          data = SBF::Client::FullFundraiser.new(JSON.parse(response.body).symbolize!)
        else
          error = SBF::Client::ErrorEntity.new(JSON.parse(response.body).symbolize!)
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: data, error: error)
      end

      def leave_team(fundraiser_id)
        join_team(fundraiser_id, 0)
      end

      def join_event(fundraiser_id, new_event_id)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/move_to_different_event",
                                                          id: fundraiser_id, new_event_id: new_event_id)

        error = SBF::Client::ErrorEntity.new(JSON.parse(response.body).symbolize!) unless ok?(response)

        SBF::Client::Api::Response.new(http_code: response.code, data: nil, error: error)
      end

      def leave_event(fundraiser_id)
        join_event(fundraiser_id, 0)
      end
    end
  end
end
