require 'stbaldricks/endpoints/lib/entity'

module SBF
  module Client
    class MessageEndpoint < SBF::Client::EntityEndpoint
      def mark_as_read(message_id)
        raise SBF::Client::Error, 'Message Id must be an Integer' unless message_id.is_a?(Integer)

        response = SBF::Client::Api::Request.post_request("#{base_uri}/mark_as_read/#{message_id}")

        error = SBF::Client::ErrorEntity.new(response) unless ok?(response)

        SBF::Client::Api::Response.new(http_code: response.code, data: response, error: error)
      end

      def mark_as_unread(message_id)
        raise SBF::Client::Error, 'Message Id must be an Integer' unless message_id.is_a?(Integer)

        response = SBF::Client::Api::Request.post_request("#{base_uri}/mark_as_unread/#{message_id}")

        error = SBF::Client::ErrorEntity.new(response) unless ok?(response)

        SBF::Client::Api::Response.new(http_code: response.code, data: response, error: error)
      end
    end
  end
end
