require 'stbaldricks/endpoints/lib/entity'

module SBF
  module Client
    class RecurringGiftEndpoint < SBF::Client::EntityEndpoint
      def sync(data)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/sync", data)

        unless ok?(response)
          parsed_response_body = JSON.parse(response.body).symbolize!
          error = SBF::Client::ErrorEntity.new(parsed_response_body)
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: response, error: error)
      end

      def change_billing_day(data)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/change_billing_day", data)

        unless ok?(response)
          parsed_response_body = JSON.parse(response.body).symbolize!
          error = SBF::Client::ErrorEntity.new(parsed_response_body)
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: response, error: error)
      end

      def change_amount(data)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/change_amount", data)

        unless ok?(response)
          parsed_response_body = JSON.parse(response.body).symbolize!
          error = SBF::Client::ErrorEntity.new(parsed_response_body)
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: response, error: error)
      end
    end
  end
end
