require 'stbaldricks/endpoints/lib/entity'

module SBF
  module Client
    class ShaveScheduleEndpoint < SBF::Client::EntityEndpoint
      def get(id, year, with = {})
        super("#{id}/#{year}", with)
      end

      def update(id, year, data, with = {})
        super("#{id}/#{year}", data, with)
      end

      def notify(data)
        response = SBF::Client::Api::Request.post_request("#{base_uri}/notify", data)

        if ok?(response)
          data = nil
        else
          parsed_response_body = JSON.parse(response.body).symbolize!
          error = SBF::Client::ErrorEntity.new(parsed_response_body)
        end

        SBF::Client::Api::Response.new(http_code: response.code, data: data, error: error)
      end
    end
  end
end
