require 'stbaldricks/entities/donation'
require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/lib/payment'

module SBF
  module Client
    class Batch < SBF::Client::TopLevelEntity
      actions DEFAULT_CRUD_ACTIONS

      module Type
        IMPORTED = 'imported'.freeze
        PROCESSED = 'processed'.freeze
      end

      attr_accessor :id
      attr_accessor :type
      multitype_attr_accessor(
        :payment_details, [
          [->(v) { v[:type] == SBF::Client::Payment::Type::CREDIT_CARD }, 'SBF::Client::Payment::CreditCardDetails'],
          [->(v) { v[:type] == SBF::Client::Payment::Type::NONCE }, 'SBF::Client::Payment::NonceDetails']
        ]
      )
      attr_accessor :amount
      attr_accessor :filename
      attr_accessor :created_at, :modified_at, :processed_at, :submitted_by
      entity_collection_attr_accessor :donations, 'SBF::Client::FullDonation', 'SBF::Client::PartialDonation'
    end
  end
end
