require 'stbaldricks/entities/lib/fundraising_page'
require 'stbaldricks/entities/lib/base'
require 'stbaldricks/entities/lib/top_level'

module SBF
  module Client
    class Campaign < SBF::Client::TopLevelEntity
      action :get
      action :find
      action :find_first

      disallow_instantiation

      class Totals < SBF::Client::BaseEntity
        attr_reader :current_year_amount_raised
        attr_reader :previous_year_amount_raised
        attr_reader :all_years_amount_raised
        attr_reader :participants
        attr_reader :shavees
      end
    end

    class PartialCampaign < Campaign
      attr_accessor :id
    end

    class FullCampaign < Campaign
      attr_accessor :id
      attr_accessor :name
      attr_accessor :website_url

      entity_attr_reader :totals, 'SBF::Client::Campaign::Totals', nil, true
      entity_attr_accessor :web_page, 'SBF::Client::WebPage', nil, true

      entity_attr_accessor :photo, 'SBF::Client::Photo', nil, true
    end
  end
end
