require 'stbaldricks/entities/lib/base'
require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/challenger'
require 'stbaldricks/entities/lib/default_cacheable'

module SBF
  module Client
    class Challenge < SBF::Client::TopLevelEntity
      include Entities::DefaultCacheable
      actions DEFAULT_CRUD_ACTIONS

      module Status
        PENDING = 'pending'.freeze
        ACCEPTED = 'accepted'.freeze
        CANCELED = 'canceled'.freeze
        DECLINED = 'declined'.freeze
      end

      attr_accessor :id
      attr_accessor :status
      attr_accessor :end_date
      entity_attr_accessor :challenger, 'SBF::Client::Challenger', nil, true
      entity_attr_accessor :challengee, 'SBF::Client::Challenger', nil, true
      attr_reader :created_at, :modified_at
      attr_accessor :modified_by
    end
  end
end
