require 'stbaldricks/endpoints/contact'
require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/person'
require 'stbaldricks/entities/contact_group'

module SBF
  module Client
    class Contact < SBF::Client::TopLevelEntity
      endpoint SBF::Client::ContactEndpoint

      actions DEFAULT_CRUD_ACTIONS

      module Type
        WEBSITE = 'website'.freeze
      end

      attr_reader :id
      entity_attr_accessor :owner, 'SBF::Client::FullPerson', 'SBF::Client::PartialPerson'
      entity_attr_accessor :person, 'SBF::Client::FullPerson', 'SBF::Client::PartialPerson'
      attr_accessor :type
      attr_reader :display_name
      attr_reader :email
      attr_reader :created_at, :modified_at
      entity_collection_attr_reader :contact_groups, 'SBF::Client::ContactGroup'
    end

    class CustomContact < SBF::Client::Contact
      endpoint SBF::Client::ContactEndpoint

      attr_accessor :id
      attr_accessor :display_name
      attr_accessor :email
    end
  end
end
