require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/person'
require 'stbaldricks/entities/contact'
require 'htmlentities'

module SBF
  module Client
    class ContactGroup < SBF::Client::TopLevelEntity
      actions DEFAULT_CRUD_ACTIONS

      attr_accessor :id
      attr_accessor :display_name
      entity_attr_accessor :owner, 'SBF::Client::FullPerson'
      multitype_collection_attr_accessor(
        :contacts,
        [
          [->(v) { v.key?(:person) && !v[:person].empty? }, 'SBF::Client::Contact'],
          [ELSE, 'SBF::Client::CustomContact']
        ]
      )
      attr_reader :created_at, :modified_at
    end
  end
end
