require 'stbaldricks/entities/lib/base'
require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/lib/default_cacheable'
require 'stbaldricks/entities/person'
require 'stbaldricks/entities/organization'
require 'stbaldricks/endpoints/deduplicator_match'

module SBF
  module Client
    class DeduplicatorMatch < SBF::Client::TopLevelEntity
      actions DEFAULT_CRUD_ACTIONS
      endpoint SBF::Client::DeduplicatorMatchEndpoint
      blacklist_action :get
      blacklist_action :save
      blacklist_action :create
      blacklist_action :delete
      blacklist_action :aggregate
      action :checkout
      action :list_checkouts
      action :release_checkout

      module Status
        READY = 'ready'.freeze
        CHECKED_OUT = 'checked_out'.freeze
        COMPLETED = 'completed'.freeze
        ERROR_OUT_OF_SYNC_ADD = 'error_out_of_sync_add'.freeze
        ERROR_OUT_OF_SYNC_UPDATE = 'error_out_of_sync_update'.freeze
      end

      attr_accessor :id
      attr_accessor :checkout_id
      attr_accessor :status
      attr_accessor :date_created
      attr_accessor :date_modified
      entity_collection_attr_accessor :persons, 'SBF::Client::FullPerson', nil, true
      entity_collection_attr_accessor :organizations, 'SBF::Client::FullOrganization', nil, true
    end
  end
end
