# frozen_string_literal: true

require 'stbaldricks/entities/lib/top_level'

module SBF
  module Client
    class Donation < SBF::Client::TopLevelEntity
      module PromoCode
        HOLIDAY_GIVING = 'holiday_giving'
        IN_PLAY = 'in_play'
        MOTHERS_DAY = 'mothers_day'
        PHINEAS = 'phineas'
        SEPTEMBER = 'september'
        IMPACT_DG = 'impact_dg'
        GIVING_TUESDAY = 'giving_tuesday'
        SURVIVOR = 'survivor'
        SPONSORSHIP = 'sponsorship'
        LAPSED_LOW = 'lapsed_low'
        LAPSED_MID = 'lapsed_mid'
        RMMEVENTS = 'rmmevents'
        YEAR_END_DG = 'year_end_dg'
        LAPSED_DG = 'lapsed_dg'
        FB_FUNDRAISER = 'fb_fundraiser'
        MOBILE_CAUSE = 'mobile_cause'
        INTERNATIONAL = 'international'
        ACS = 'acs'
        HEAD_SHAVING = 'head_shaving'
        SPORT_CLIPS = 'sport_clips'
        TWENTIETH_ANNIVERSARY = '20th_anniversary'
        DWYW = 'dwyw'
        GRANTS = 'grants'
        SUMMER = 'summer'
        ADVOCACY = 'advocacy'
        MISSION = 'mission'
        RECURRING_GIVING = 'recurring_giving'
        ACSEVENTS = 'acsevents'
        HS_TO_DONOR = 'hs_to_donor'
        WIRELESS_VISION = 'wireless_vision'
        BMC = 'bmc'
        DUTCH_BROS = 'dutch_bros'
        FADO = 'fado'
        SAP = 'sap'
        BRIGADE = 'brigade'
        SCHICK = 'schick'
        BATTLE = 'battle'
        CCQR = 'ccqr'
        QREVENTPRINTOUT = 'qreventprintout'
        PDASHQR = 'pdashqr'
        APPEAL = 'appeal'
        INSTAGRAM = 'instagram'
        BLANK9 = 'blank9'
        BLANK10 = 'blank10'
        BLANK11 = 'blank11'
        BLANK12 = 'blank12'
        BLANK13 = 'blank13'
        BLANK14 = 'blank14'
        BLANK15 = 'blank15'
        BLANK16 = 'blank16'
        BLANK17 = 'blank17'
        BLANK18 = 'blank18'
        BLANK19 = 'blank19'
        BLANK20 = 'blank20'
        BLANK21 = 'blank21'

        def self.to_a
          # Defining the array explicitly, in order rather than const_getting since some things in website-ruby depend on the order
          [HOLIDAY_GIVING, IN_PLAY, MOTHERS_DAY, PHINEAS, SEPTEMBER, IMPACT_DG,
           GIVING_TUESDAY, SURVIVOR, SPONSORSHIP, LAPSED_LOW, LAPSED_MID, RMMEVENTS, YEAR_END_DG, LAPSED_DG, FB_FUNDRAISER,
           MOBILE_CAUSE, INTERNATIONAL, ACS, HEAD_SHAVING, SPORT_CLIPS, TWENTIETH_ANNIVERSARY, DWYW, GRANTS, SUMMER,
           ADVOCACY, MISSION, RECURRING_GIVING, ACSEVENTS, HS_TO_DONOR, WIRELESS_VISION, BMC, DUTCH_BROS, FADO, SAP, BRIGADE,
           SCHICK, BATTLE, CCQR, QREVENTPRINTOUT, PDASHQR, APPEAL, INSTAGRAM, BLANK9, BLANK10, BLANK11, BLANK12, BLANK13,
           BLANK14, BLANK15, BLANK16, BLANK17, BLANK18, BLANK19, BLANK20, BLANK21]
        end
      end
    end
  end
end
