require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/event'
require 'htmlentities'

module SBF
  module Client
    class EventSupporter < SBF::Client::TopLevelEntity
      actions DEFAULT_CRUD_ACTIONS

      disallow_instantiation
      attr_accessor :id, :sort_order
    end

    class PartialEventSupporter < EventSupporter
    end

    class FullEventSupporter < EventSupporter
      attr_accessor :photo_url
      attr_accessor :name, :url
      attr_reader :created_at, :modified_at
      entity_attr_accessor :event, 'SBF::Client::FullEvent', 'SBF::Client::PartialEvent', true
      entity_attr_accessor :photo, 'SBF::Client::Photo'
    end
  end
end
