require 'stbaldricks/entities/lib/base'
require 'stbaldricks/entities/lib/address'
require 'stbaldricks/entities/lib/default_cacheable'
require 'stbaldricks/entities/lib/top_level'

module SBF
  module Client
    class Institution < SBF::Client::TopLevelEntity
      include Entities::DefaultCacheable
      actions DEFAULT_CRUD_ACTIONS
      blacklist_action :aggregate
      blacklist_action :create
      blacklist_action :update
      blacklist_action :delete

      attr_accessor :id
    end

    class PartialInstitution < SBF::Client::Institution; end

    class FullInstitution < SBF::Client::Institution
      attr_accessor :name
      entity_attr_accessor :address, 'SBF::Client::Address'
      attr_reader :created_at
      attr_reader :modified_at
    end
  end
end
