require 'stbaldricks/entities/lib/address'
require 'stbaldricks/entities/lib/name'
require 'stbaldricks/entities/lib/fundraising_page'
require 'stbaldricks/entities/person'
require 'stbaldricks/entities/lib/top_level'

module SBF
  module Client
    class InternationalPartner < SBF::Client::TopLevelEntity
      actions DEFAULT_CRUD_ACTIONS
      blacklist_action :create
      blacklist_action :update
      blacklist_action :delete

      disallow_instantiation

      module Status
        ACTIVE = 'active'.freeze
        PENDING = 'pending'.freeze
      end

      class WebPage < SBF::Client::BaseEntity
        attr_accessor :url
        attr_accessor :custom_url_segment
      end

      class Link < SBF::Client::BaseEntity
        attr_accessor :url
        attr_accessor :text
      end
    end

    class PartialInternationalPartner < SBF::Client::InternationalPartner
      attr_accessor :id
    end

    class FullInternationalPartner < SBF::Client::InternationalPartner
      attr_accessor :id
      attr_accessor :status
      attr_accessor :year
      attr_accessor :country
      attr_accessor :country_name
      attr_accessor :name
      attr_accessor :message
      attr_accessor :description
      entity_attr_accessor :web_page, 'SBF::Client::InternationalPartner::WebPage'
      entity_attr_accessor :link, 'SBF::Client::InternationalPartner::Link'
      attr_accessor :donate_url
      attr_accessor :base_photo_url

      attr_accessor :created_at

      def active?
        status == SBF::Client::InternationalPartner::Status::ACTIVE
      end
    end
  end
end
