require 'stbaldricks/endpoints/kid_institution'
require 'stbaldricks/entities/kid'
require 'stbaldricks/entities/institution'
require 'stbaldricks/entities/lib/top_level'

module SBF
  module Client
    class KidInstitution < SBF::Client::TopLevelEntity
      endpoint SBF::Client::KidInstitutionEndpoint
      actions DEFAULT_CRUD_ACTIONS
      blacklist_action :get
      blacklist_action :update
      blacklist_action :aggregate

      entity_attr_accessor :kid, 'SBF::Client::FullKid', 'SBF::Client::PartialKid', true
      entity_attr_accessor :institution, 'SBF::Client::FullInstitution', 'SBF::Client::PartialInstitution', true
    end
  end
end
