require 'stbaldricks/entities/lib/base'

module SBF
  module Client
    class Address < SBF::Client::BaseEntity
      module Type
        HOME = 'home'.freeze
        BUSINESS = 'business'.freeze
      end

      attr_accessor :type
      attr_accessor :business_name
      attr_accessor :address1, :address2, :city, :state, :state_name, :zip, :country, :country_name
      attr_accessor :latitude, :longitude

      def city_state_zip
        csz = ''
        csz += @city + ', ' unless @city.nil?
        csz += @state + ' ' unless @state.nil?
        csz += @zip unless @zip.nil?
        csz.strip
      end
    end
  end
end
