require 'stbaldricks/entities/lib/base'

# - JUST CODED THIS SO IT WILL RESPOND WITH DOT NOTATION ex, thing.id instead of thing['id']
module SBF
  module Client
    class NotImplementedObject < SBF::Client::BaseEntity
      attr_accessor :props

      def initialize(attributes = {})
        @props = {}.tap do |hsh|
          attributes.each do |k, v|
            hsh[k.to_sym] = v
          end
        end

        super
      end

      # rubocop:disable Style/MissingRespondToMissing
      def method_missing(name)
        return @props[name.to_sym] if @props.key?(name.to_sym)

        super.method_missing(name)
      end
      # rubocop:enable Style/MissingRespondToMissing

      def to_hash
        {}.tap do |hsh|
          props.each { |k, v| hsh[k] = v }
          self.class.defined_attributes.each { |name| hsh[name] = send(name.to_sym) unless hsh.key?(name.to_sym) || name.to_sym == :props }
        end
      end
    end
  end
end
