require 'stbaldricks/entities/lib/base'
require 'stbaldricks/enums/permission'
require 'set'

module SBF
  module Client
    class Permissions < SBF::Client::BaseEntity
      attr_accessor :is_owner
      attr_accessor :permission_ids

      # rubocop:disable Style/MissingRespondToMissing
      def method_missing(method, *arguments, &block)
        # If the method starts with 'can', assume they are trying to determine if the user has the permission
        # in their list of permission ids and return the result
        if method.to_s.start_with?('can_')
          const_name = method.to_s.split('can_').last.upcase.to_sym

          if SBF::Client::Permission.constants(false).include?(const_name)
            permission_id = SBF::Client::Permission.const_get(const_name, false)
            return permission_ids.include?(permission_id)

          end
        end

        super
      end
      # rubocop:enable Style/MissingRespondToMissing
    end

    class PermissionsAtEvent < SBF::Client::BaseEntity
      attr_accessor :granted
      attr_accessor :inherited_from_roles
    end
  end
end
