require 'stbaldricks/entities/lib/base'

module SBF
  module Client
    class Phone < SBF::Client::BaseEntity
      module Type
        HOME = 'home'.freeze
        BUSINESS = 'business'.freeze
        MOBILE = 'mobile'.freeze
      end

      attr_accessor :type
      attr_accessor :number, :extension

      # (402)555-5555 --> tel:4025555555
      def format_href
        return 'tel:' + number.gsub(/\D/, '') unless number.nil?

        number
      end

      # This kinda handles extensions, at least? We never actually populate :extension, do we?
      # (402)555-5555 ext. 5555 --> 402.555.555 x5555
      def format_number
        return number.gsub(/\D/, '').gsub(/(\d{3})(\d{3})(\d{4})(\d*)/, '\1.\2.\3 x\4').gsub(/x$/, '').rstrip unless number.nil?

        number
      end
    end
  end
end
