require 'stbaldricks/endpoints/message'
require 'stbaldricks/entities/lib/base'
require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/contact'
require 'stbaldricks/entities/person'

module SBF
  module Client
    class Message < SBF::Client::TopLevelEntity
      endpoint SBF::Client::MessageEndpoint

      actions DEFAULT_CRUD_ACTIONS
      action :mark_as_read
      action :mark_as_unread

      module Type
        MEMBERS_COMMUNICATION = 'members_communication'.freeze
        REPLY = 'reply'.freeze
      end

      module Status
        PENDING = 'pending'.freeze
        SENT = 'sent'.freeze
        DELETED = 'deleted'.freeze
      end

      class Recipient < SBF::Client::BaseEntity
        module Status
          UNREAD = 'unread'.freeze
          READ = 'read'.freeze
          DELETED = 'deleted'.freeze
        end

        attr_accessor :id
        attr_accessor :status

        attr_accessor :message_id
        entity_attr_reader :person, 'SBF::Client::FullPerson', 'SBF::Client::PartialPerson'
        attr_accessor :display_name
        attr_accessor :email

        attr_reader :modified_at
      end

      attr_accessor :id
      attr_accessor :type
      attr_accessor :status

      entity_collection_attr_accessor :to, 'SBF::Client::Message::Recipient'
      attr_reader :from_ip
      entity_attr_reader :from_person, 'SBF::Client::FullPerson', 'SBF::Client::PartialPerson'
      attr_reader :from_email
      attr_reader :display_name
      attr_accessor :subject
      attr_accessor :body

      attr_reader :created_at, :modified_at, :sent_at
    end
  end
end
