require 'stbaldricks/entities/lib/base'

module SBF
  module Client
    module Api
      class Response < SBF::Client::BaseEntity
        attr_accessor :http_code, :data, :error

        def initialize(http_code: nil, data: nil, error: nil)
          @http_code = http_code
          @data = data
          @error = error || SBF::Client::ErrorEntity.new(nil)
          @errors = SBF::Client::Entity::Errors.new(self, http_code)
          add_errors(@error) unless @error.nil? || @error.empty?
          @errors.instance_variable_set(:@http_code, http_code)
        end

        def success?
          http_code.to_s.start_with?('2')
        end

        def to_json(opts = nil)
          to_hash.to_json(opts)
        end

        def to_hash
          {
            http_code: http_code,
            data: data,
            error: error
          }
        end
      end
    end
  end
end
