require 'stbaldricks/entities/lib/base'
require 'stbaldricks/entities/lib/top_level'
require 'stbaldricks/entities/lib/cacheable'

module SBF
  module Client
    class Summary < SBF::Client::TopLevelEntity
      include Entities::Cacheable
      action :find
      action :find_first

      cache_id -> { [year] }
      cache_id_from_hash ->(h) { [h[:year]] }

      attr_accessor :year

      entity_attr_reader :yearly_totals, 'SBF::Client::Summary::Totals'
      entity_attr_reader :monthly_totals, 'SBF::Client::Summary::Totals'
      entity_attr_reader :weekly_totals, 'SBF::Client::Summary::Totals'

      class Totals < SBF::Client::BaseEntity
        attr_reader :donations
        attr_reader :events
        attr_reader :male_shavees
        attr_reader :female_shavees
        attr_reader :barbers
        attr_reader :participants
        attr_reader :fundraisers
      end
    end
  end
end
