# frozen_string_literal: true

module SBF
  module Client
    module CancerType
      ACUTE_LYMPHOBLASTIC_LEUKEMIA = 'Acute lymphoblastic leukemia (ALL)'
      ACUTE_MYELOID_LEUKEMIA = 'Acute myeloid leukemia (AML)'
      BRAIN_OR_SPINAL_CORD_TUMOR = 'Brain or spinal cord tumor'
      CLEAR_CELL_SARCOMA_OF_THE_KIDNEY = 'Clear cell sarcoma of the kidney'
      EWING_SARCOMA = 'Ewing sarcoma'
      GERM_CELL_TUMOR = 'Germ cell tumor'
      HEPATOBLASTOMA = 'Hepatoblastoma'
      HODGKIN_LYMPHOMA = 'Hodgkin lymphoma'
      LANGERHANS_CELL_HISTIOCYTOSIS = 'Langerhans Cell Histiocytosis (LCH)'
      LYMPHOMA = 'Lymphoma'
      NEUROBLASTOMA = 'Neuroblastoma'
      NON_HODGKIN_LYMPHOMA = 'Non-Hodgkin lymphoma'
      OSTEOSARCOMA = 'Osteosarcoma'
      RETINOBLASTOMA = 'Retinoblastoma'
      RHABDOMYOSARCOMA = 'Rhabdomyosarcoma'
      WILMS_OR_OTHER_KIDNEY_TUMOR = 'Wilms or other kidney tumor'
      ADULT_WITH_A_TYPE_OF_CHILDHOOD_CANCER = 'Adult with a type of childhood cancer'
      OTHER_CHILDHOOD_CANCER = 'Other childhood cancer'

      @list = {
        ACUTE_LYMPHOBLASTIC_LEUKEMIA => 'acute_lymphoblastic_leukemia',
        ACUTE_MYELOID_LEUKEMIA => 'acute_myeloid_leukemia',
        BRAIN_OR_SPINAL_CORD_TUMOR => 'brain_or_spinal_cord_tumor',
        CLEAR_CELL_SARCOMA_OF_THE_KIDNEY => 'kidney_sarcoma',
        EWING_SARCOMA => 'ewing_sarcoma',
        GERM_CELL_TUMOR => 'germ_cell_tumor',
        HEPATOBLASTOMA => 'hepatoblastoma',
        HODGKIN_LYMPHOMA => 'hodgkin_lymphoma',
        LANGERHANS_CELL_HISTIOCYTOSIS => 'langerhans_cell_histiocytosis',
        LYMPHOMA => 'lymphoma',
        NEUROBLASTOMA => 'neuroblastoma',
        NON_HODGKIN_LYMPHOMA => 'non_hodgkin_lymphoma',
        OSTEOSARCOMA => 'osteosarcoma',
        RETINOBLASTOMA => 'retinoblastoma',
        RHABDOMYOSARCOMA => 'rhabdomyosarcoma',
        WILMS_OR_OTHER_KIDNEY_TUMOR => 'wilms_or_other_kidney_tumor',
        ADULT_WITH_A_TYPE_OF_CHILDHOOD_CANCER => 'adult_with_childhood_cancer',
        OTHER_CHILDHOOD_CANCER => 'other_childhood_cancer'
      }.freeze

      class << self
        attr_reader :list
      end
    end
  end
end
