# frozen_string_literal: true

module SBF
  module Client
    module Country
      AMERICAN_SAMOA = 'American Samoa'
      ANGUILLA = 'Anguilla'
      ANTIGUA_AND_BARBUDA = 'Antigua And Barbuda'
      ARGENTINA = 'Argentina'
      ARMENIA = 'Armenia'
      ARUBA = 'Aruba'
      AUSTRALIA = 'Australia'
      AUSTRIA = 'Austria'
      AZERBAIJAN = 'Azerbaijan'
      BAHAMAS = 'Bahamas'
      BAHRAIN = 'Bahrain'
      BANGLADESH = 'Bangladesh'
      BARBADOS = 'Barbados'
      BELARUS = 'Belarus'
      BELGIUM = 'Belgium'
      BELIZE = 'Belize'
      BERMUDA = 'Bermuda'
      BRAZIL = 'Brazil'
      BULGARIA = 'Bulgaria'
      CANADA = 'Canada'
      CAYMAN_ISLANDS = 'Cayman Islands'
      CHILE = 'Chile'
      CHINA = 'China'
      COLUMBIA = 'Colombia'
      COSTA_RICA = 'Costa Rica'
      CROATIA = 'Croatia'
      CUBA = 'Cuba'
      CURACAO = 'Curacao'
      CYPRUS = 'Cyprus'
      CZECH_REPUBLIC = 'Czech Republic'
      DENMARK = 'Denmark'
      DOMINICA = 'Dominica'
      DOMINICAN_REPUBLIC = 'Dominican Republic'
      ECUADOR = 'Ecuador'
      EGYPT = 'Egypt'
      EL_SALVADOR = 'El Salvador'
      FINLAND = 'Finland'
      FRANCE = 'France'
      GERMANY = 'Germany'
      GREECE = 'Greece'
      GRENADA = 'Grenada'
      HAITI = 'Haiti'
      HONDURAS = 'Honduras'
      HONG_KONG = 'Hong Kong'
      HUNGARY = 'Hungary'
      ICELAND = 'Iceland'
      INDIA = 'India'
      INDONESIA = 'Indonesia'
      IRAN = 'Iran'
      IRAQ = 'Iraq'
      IRELAND = 'Ireland'
      ISRAEL = 'Israel'
      ITALY = 'Italy'
      JAMAICA = 'Jamaica'
      JAPAN = 'Japan'
      KENYA = 'Kenya'
      KUWAIT = 'Kuwait'
      LEBANON = 'Lebanon'
      LITHUANIA = 'Lithuania'
      LUXEMBOURG = 'Luxembourg'
      MACAO = 'Macao'
      MALAWI = 'Malawi'
      MALAYSIA = 'Malaysia'
      MALTA = 'Malta'
      MEXICO = 'Mexico'
      MOLDOVA = 'Moldova'
      MONTSERRAT = 'Montserrat'
      NETHERLANDS = 'Netherlands (The)'
      NEW_ZEALAND = 'New Zealand'
      NICARAGUA = 'Nicaragua'
      NORWAY = 'Norway'
      OMAN = 'Oman'
      PAKISTAN = 'Pakistan'
      PERU = 'Peru'
      PHILIPPINES = 'Philippines'
      POLAND = 'Poland'
      PORTUGAL = 'Portugal'
      QATAR = 'Qatar'
      ROMANIA = 'Romania'
      RUSSIA = 'Russia'
      SAINT_KITTS_AND_NEVIS = 'Saint Kitts And Nevis'
      SAINT_LUCIA = 'Saint Lucia'
      SAINT_MARTIN = 'Saint Martin'
      SAINT_VINCENT_AND_THE_GRENADINES = 'Saint Vincent And The Grenadines'
      SAUDI_ARABIA = 'Saudi Arabia'
      SINGAPORE = 'Singapore'
      SINT_MAARTEN = 'Sint Maarten'
      SLOVAKIA = 'Slovakia'
      SLOVENIA = 'Slovenia'
      SOUTH_AFRICA = 'South Africa'
      SOUTH_KOREA = 'South Korea'
      SPAIN = 'Spain'
      SRI_LANKA = 'Sri Lanka'
      SWEDEN = 'Sweden'
      SWITZERLAND = 'Switzerland'
      TAIWAN = 'Taiwan'
      THAILAND = 'Thailand'
      TONGA = 'Tonga'
      TRINIDAD_AND_TOBAGO = 'Trinidad And Tobago'
      TURKEY = 'Turkey'
      TURKS_AND_CAICOS_ISLANDS = 'Turks And Caicos Islands'
      UGANDA = 'Uganda'
      UKRAINE = 'Ukraine'
      UNITED_ARAB_EMIRATES = 'United Arab Emirates'
      UNITED_KINGDOM = 'United Kingdom'
      UNITED_STATES = 'United States'
      URUGUAY = 'Uruguay'
      VENEZUELA = 'Venezuela'
      VIETNAM = 'Vietnam'
      VIRGIN_ISLANDS_BRITISH = 'Virgin Islands (British)'

      @list = {
        UNITED_STATES => :US,
        AMERICAN_SAMOA => :AS,
        ANGUILLA => :AI,
        ANTIGUA_AND_BARBUDA => :AG,
        ARGENTINA => :AR,
        ARMENIA => :AM,
        ARUBA => :AW,
        AUSTRALIA => :AU,
        AUSTRIA => :AT,
        AZERBAIJAN => :AZ,
        BAHAMAS => :BS,
        BAHRAIN => :BH,
        BANGLADESH => :BD,
        BARBADOS => :BB,
        BELARUS => :BY,
        BELGIUM => :BE,
        BELIZE => :BZ,
        BERMUDA => :BM,
        BRAZIL => :BR,
        BULGARIA => :BG,
        CANADA => :CA,
        CAYMAN_ISLANDS => :KY,
        CHILE => :CL,
        CHINA => :CN,
        COLUMBIA => :CO,
        CROATIA => :HR,
        COSTA_RICA => :CR,
        CUBA => :CU,
        CURACAO => :CW,
        CYPRUS => :CY,
        CZECH_REPUBLIC => :CZ,
        DENMARK => :DK,
        DOMINICA => :DM,
        DOMINICAN_REPUBLIC => :DO,
        ECUADOR => :EC,
        EGYPT => :EG,
        EL_SALVADOR => :SV,
        FINLAND => :FI,
        FRANCE => :FR,
        GERMANY => :DE,
        GREECE => :GR,
        GRENADA => :GD,
        HAITI => :HT,
        HONDURAS => :HN,
        HONG_KONG => :HK,
        HUNGARY => :HU,
        ICELAND => :IS,
        INDIA => :IN,
        INDONESIA => :ID,
        IRAN => :IR,
        IRAQ => :IQ,
        IRELAND => :IE,
        ISRAEL => :IL,
        ITALY => :IT,
        JAMAICA => :JM,
        JAPAN => :JP,
        KENYA => :KE,
        KUWAIT => :KW,
        LEBANON => :LB,
        LITHUANIA => :LT,
        LUXEMBOURG => :LU,
        MACAO => :MO,
        MALAWI => :MW,
        MALAYSIA => :MY,
        MALTA => :MT,
        MEXICO => :MX,
        MOLDOVA => :MD,
        MONTSERRAT => :MS,
        NETHERLANDS => :NL,
        NEW_ZEALAND => :NZ,
        NICARAGUA => :NI,
        NORWAY => :NO,
        OMAN => :OM,
        PAKISTAN => :PK,
        PERU => :PE,
        PHILIPPINES => :PH,
        POLAND => :PL,
        PORTUGAL => :PT,
        QATAR => :QA,
        ROMANIA => :RO,
        RUSSIA => :RU,
        SAINT_KITTS_AND_NEVIS => :KN,
        SAINT_LUCIA => :LC,
        SAINT_MARTIN => :MF,
        SAINT_VINCENT_AND_THE_GRENADINES => :VC,
        SAUDI_ARABIA => :SA,
        SINGAPORE => :SG,
        SINT_MAARTEN => :SX,
        SLOVAKIA => :SK,
        SLOVENIA => :SI,
        SOUTH_AFRICA => :ZA,
        SOUTH_KOREA => :KR,
        SPAIN => :ES,
        SRI_LANKA => :LK,
        SWEDEN => :SE,
        SWITZERLAND => :CH,
        TAIWAN => :TW,
        THAILAND => :TH,
        TONGA => :TO,
        TRINIDAD_AND_TOBAGO => :TT,
        TURKEY => :TR,
        TURKS_AND_CAICOS_ISLANDS => :TC,
        UGANDA => :UG,
        UKRAINE => :UA,
        UNITED_ARAB_EMIRATES => :AE,
        UNITED_KINGDOM => :UK,
        URUGUAY => :UY,
        VENEZUELA => :VE,
        VIETNAM => :VN,
        VIRGIN_ISLANDS_BRITISH => :VG
      }.freeze

      class << self
        attr_reader :list
      end
    end
  end
end
