module SBF
  module Client
    module Feature
      # Features added to this enum list will be toggleable by sbf users with a members account
      # This allows users to opt in or out of specific features which is useful when rolling out a large new feature gradually to ensure the
      # new feature is stable and user's are able to acclimate gradually to a new interface.
      # When a feature is fully rolled out the data for the feature should be cleared from the rollout db and the enum removed.
      # Only add features here if you intend to allow users a choice.

      # EXAMPLE_FEATURE = 'the_rollout_feature_name'

      @list = {
        # EXAMPLE_FEATURE => :the_rollout_feature_name
      }.freeze

      @descriptions = {
        # EXAMPLE_FEATURE => "The description of the feature which displays on the user's settings page"
      }.freeze

      def self.description(feature)
        @descriptions[feature]
      end

      class << self
        attr_reader :list
      end
    end
  end
end
