# frozen_string_literal: true

module SBF
  module Client
    module ModelType
      CAMPAIGN = 'c'
      EVENT = 'e'
      EVENT_APPLICATION = 'ea'
      EVENT_SUPPORTER = 'es'
      FUND = 'f'
      FUNDRAISER = 'fr'
      KID = 'k'
      MEMORIAL = 'me'
      PARTICIPANT = 'p'
      PROFILE = 'pr'
      TEAM = 't'
      USER = 'u'
      RECURRING_GIFT = 'r'

      @list = {
        CAMPAIGN => 'campaign',
        EVENT => 'event',
        EVENT_APPLICATION => 'event_application',
        EVENT_SUPPORTER => 'event_supporter',
        FUND => 'fund',
        FUNDRAISER => 'fundraiser',
        KID => 'kid',
        MEMORIAL => 'memorial',
        PARTICIPANT => 'participant',
        PROFILE => 'profile',
        TEAM => 'team',
        USER => 'user',
        RECURRING_GIFT => 'recurring_gift'
      }.freeze

      class << self
        attr_reader :list
      end
    end
  end
end
