module SBF
  module Client
    # Generic error for our client library
    class StandardError < ::StandardError; end

    # Errors that arise from misuse of the Client Library
    class Error < SBF::Client::StandardError; end

    # Errors from passing an invalid URI to the client
    class InvalidURIError < SBF::Client::Error; end

    # Error that occurs when you try to access something you didn't include in the request
    class DataNotProvidedError < SBF::Client::StandardError; end

    # Error that occurs when invalid data is passed into a cachable method
    class CacheableInvalidDataError < SBF::Client::StandardError; end
  end
end
