require 'singleton'
require 'stbaldricks/configuration'

module SBF
  module Client
    class LOG
      include Singleton

      # rubocop:disable Style/MutableConstant
      REQUIRED_METHODS = %i(debug info warn error fatal unknown add level)
      # rubocop:enable Style/MutableConstant

      # rubocop:disable Style/MissingRespondToMissing
      def self.method_missing(sym, *args, &block)
        SBF::Client::Configuration.logger.send(sym, *args, &block)
      end
      # rubocop:enable Style/MissingRespondToMissing
    end
  end
end
